SystemOrganization addCategory: #'Network-MIME'!

!MacFileDirectory class methodsFor: '*Network-MIME' stamp: 'JMM 4/3/2006 11:04'!
getTypeToMimeMappings
	^TypeToMimeMappings! !

!ByteArray methodsFor: '*Network-Mime' stamp: 'StephaneDucasse 1/15/2010 16:03'!
base64Encoded
	"Encode the receiver as base64"
	"'Hello World' asByteArray base64Encoded"
	^(Base64MimeConverter mimeEncode: self readStream) contents! !

Object subclass: #MIMEDocument
	instanceVariableNames: 'type contents contentStream uri'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-MIME'!

!MIMEDocument commentStamp: '<historical>' prior: 0!
a MIME object, along with its type and the URL it was found at (if any)!

!MIMEDocument class methodsFor: 'instance creation' stamp: 'ls 7/23/1998 22:59'!
content: aString
	^self contentType: self defaultContentType  content: aString! !

!MIMEDocument class methodsFor: 'instance creation' stamp: 'mir 3/4/2002 18:26'!
contentStream: aStream
	^self contentStream: aStream mimeType: MIMEType defaultStream! !

!MIMEDocument class methodsFor: 'instance creation' stamp: 'mir 3/27/2005 10:52'!
contentStream: aStream mimeType: aMimeType 
	"create a MIMEDocument with the given content-type and contentStream"
	"MIMEDocument mimeType: 'text/plain' asMIMEType contentStream: (ReadStream on: 'This is a test')"
	
	^self contentStream: aStream mimeType: aMimeType uri: aStream uri! !

!MIMEDocument class methodsFor: 'instance creation' stamp: 'mir 3/27/2005 10:52'!
contentStream: aStream mimeType: aMimeType uri: aURI
	"create a MIMEDocument with the given content-type and contentStream"
	"MIMEDocument mimeType: 'text/plain' asMIMEType contentStream: (ReadStream on: 'This is a test')"
	
	^self new contentStream: aStream mimeType: aMimeType uri: aURI! !

!MIMEDocument class methodsFor: 'compatibility' stamp: 'MarcusDenker 2/15/2010 09:32'!
contentType: aMIMEType  content: content
	"create a MIMEObject with the given content-type and content"
	"MIMEObject contentType: 'text/plain' content: 'This is a test'"
	
	| ans idx |
	ans := self new.
	ans privateContent: content.

	"parse the content-type"
	(aMIMEType isNil or: [
		idx := aMIMEType asString  indexOf: $/.
		idx = 0]) 
	ifTrue: [ 
		ans type: (MIMEType main: 'application' sub: 'octet-stream')]
	ifFalse: [ 
		ans type: (MIMEType main: (aMIMEType asString copyFrom: 1 to: idx-1) sub:
(aMIMEType asString copyFrom: idx+1 to: aMIMEType asString size))].

	^ans! !

!MIMEDocument class methodsFor: 'compatibility' stamp: 'Noury 6/15/2009 22:54'!
contentType: type content: content url: url
	^self contents: content mimeType: (MIMEType fromMIMEString: type asString) uri: url! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 12:25'!
contentTypeFormData
	^'application/x-www-form-urlencoded'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 13:05'!
contentTypeHtml
	^'text/html'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 12:25'!
contentTypeMultipart
	^'multipart/form-data'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 13:05'!
contentTypePlainText
	^'text/plain'! !

!MIMEDocument class methodsFor: 'content-types' stamp: 'bolot 5/16/1999 13:05'!
contentTypeXml
	^'text/xml'! !

!MIMEDocument class methodsFor: 'instance creation' stamp: 'mir 3/4/2002 18:23'!
contents: aString
	^self contents: aString mimeType: MIMEType defaultStream! !

!MIMEDocument class methodsFor: 'instance creation' stamp: 'mir 3/27/2005 10:54'!
contents: content mimeType: aMimeType 
	"create a MIMEDocument with the given content-type and content"
	"MIMEDocument mimeType: 'text/plain' asMIMEType content: 'This is a test'"
	
	^self contents: content mimeType: aMimeType uri: nil! !

!MIMEDocument class methodsFor: 'instance creation' stamp: 'mir 3/27/2005 10:57'!
contents: content mimeType: aMimeType uri: aURL
	"create a MIMEDocument with the given content-type and content"
	"MIMEDocument mimeType: 'text/plain' asMIMEType content: 'This is a test'"
	
	^self new contents: content mimeType: aMimeType uri: aURL! !

!MIMEDocument class methodsFor: 'compatibility' stamp: 'michael.rueger 2/25/2009 12:36'!
defaultContentType
	^self defaultMIMEType asString! !

!MIMEDocument class methodsFor: 'accessing' stamp: 'michael.rueger 2/25/2009 12:35'!
defaultMIMEType
	^MIMEType fromMIMEString: 'application/octet-stream'! !

!MIMEDocument class methodsFor: 'compatibility' stamp: 'michael.rueger 2/25/2009 13:05'!
guessContentTypeFromExtension: ext
	"guesses a content type from the extension"
	^(self guessTypeFromExtension: ext) asString! !

!MIMEDocument class methodsFor: 'compatibility' stamp: 'michael.rueger 2/25/2009 13:05'!
guessTypeFromExtension: ext
	"guesses a content type from the extension"
	^self guessTypeFromName: ext! !

!MIMEDocument class methodsFor: 'compatibility' stamp: 'michael.rueger 1/8/2009 18:59'!
guessTypeFromName: url
	"guesses a content type from the url"
		^MIMEType forURIReturnSingleMimeTypeOrDefault: url asString asURI! !

!MIMEDocument class methodsFor: 'compatibility' stamp: 'michael.rueger 2/25/2009 12:29'!
resetMIMEdatabase
	"no-op for catching Kom override"! !

!MIMEDocument methodsFor: 'compatibility' stamp: 'mir 3/22/2005 22:55'!
content
	^self contents! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/4/2002 18:19'!
contentStream
	"Answer a RWBinaryOrTextStream on the contents."

	contentStream
		ifNil: [contentStream := contents
				ifNil: [self contentStreamOnURI]
				ifNotNil: [(RWBinaryOrTextStream with: self contents) reset]].
	^contentStream! !

!MIMEDocument methodsFor: 'private' stamp: 'mir 3/27/2005 10:53'!
contentStream: aStream mimeType: aMimeType uri: aUri
	type := aMimeType.
	contentStream := aStream.
	uri := aUri! !

!MIMEDocument methodsFor: 'private' stamp: 'mir 3/27/2005 10:50'!
contentStreamOnURI
	^self uri contentStream! !

!MIMEDocument methodsFor: 'compatibility' stamp: 'mir 3/4/2002 17:46'!
contentType
	^self mimeType asString! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/24/2005 17:26'!
contents
	"Answer the receiver's raw data. If we have a stream to read from. Read in the data, cache it and discard the stream."

	contents ifNil: [contents := self getContentFromStream].
	^contents! !

!MIMEDocument methodsFor: 'private' stamp: 'mir 3/27/2005 10:53'!
contents: contentStringOrBytes mimeType: aMimeType uri: aURI
	type := aMimeType.
	contents := contentStringOrBytes.
	uri := aURI! !

!MIMEDocument methodsFor: 'private' stamp: 'mir 3/26/2005 11:12'!
discardContentStream
	contentStream ifNotNil: [contentStream close].
	contentStream := nil! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/26/2005 11:13'!
discardContents
	contents := nil.
	self discardContentStream! !

!MIMEDocument methodsFor: 'private' stamp: 'mir 3/24/2005 17:37'!
getContentFromStream
	| streamContents |
	streamContents := self contentStream contents.
	self discardContentStream.
	^streamContents! !

!MIMEDocument methodsFor: 'testing' stamp: 'sbw 1/21/2001 11:13'!
isGif
	^ self mainType = 'image'
		and: [self subType = 'gif']! !

!MIMEDocument methodsFor: 'testing' stamp: 'sbw 1/21/2001 11:15'!
isJpeg
	^ self mainType = 'image'
		and: [self subType = 'jpeg' | (self subType = 'jpg')]! !

!MIMEDocument methodsFor: 'testing' stamp: 'ls 4/30/2000 18:07'!
isMultipart
	^self mainType = 'multipart'! !

!MIMEDocument methodsFor: 'testing' stamp: 'ls 4/30/2000 18:45'!
isMultipartAlternative
	"whether the document is in a multipart format where the parts are alternates"
	^ self contentType = 'multipart/alternative'
! !

!MIMEDocument methodsFor: 'testing' stamp: 'st 9/18/2004 23:37'!
isPng
	^ self mainType = 'image'
		and: [self subType = 'png']! !

!MIMEDocument methodsFor: 'testing' stamp: 'st 9/18/2004 23:38'!
isPnm
	^ self mainType = 'image'
		and: [self subType = 'pnm']! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/4/2002 17:19'!
mainType
	^self mimeType main! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/4/2002 17:19'!
mimeType
	^type! !

!MIMEDocument methodsFor: 'accessing' stamp: 'damiencassou 5/30/2008 15:52'!
parts
	"Return the parts of this message.  There is a far more reliable implementation of parts in MailMessage, but for now we are continuing to use this implementation"
	| parseStream currLine separator msgStream messages |
	self isMultipart ifFalse: 
		[ ^ #() ].
	parseStream := self content readStream.
	currLine := ''.
	[ '--*' match: currLine ] whileFalse: [ currLine := parseStream nextLine ].
	separator := currLine copy.
	msgStream := LimitingLineStreamWrapper 
		on: parseStream
		delimiter: separator.
	messages := OrderedCollection new.
	[ parseStream atEnd ] whileFalse: 
		[ messages add: msgStream upToEnd.
		msgStream skipThisLine ].
	^ messages collect: [ :e | MailMessage from: e ]! !

!MIMEDocument methodsFor: 'printing' stamp: 'mir 3/26/2005 17:48'!
printOn: aStream
	aStream nextPutAll: self class name;
		nextPutAll: ' (';
		nextPutAll: self mimeType asString;
		nextPutAll: ', '.
	contents
		ifNotNil: [aStream
			nextPutAll: self contents size printString;
			nextPutAll: ' bytes)']
		ifNil: [aStream nextPutAll: 'unknown size)'].! !

!MIMEDocument methodsFor: 'private' stamp: 'mir 11/8/2005 13:39'!
privateContent: aString
	contents := aString! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/4/2002 17:19'!
subType
	^self mimeType sub! !

!MIMEDocument methodsFor: 'accessing' stamp: 'sma 4/28/2000 14:48'!
type
	"Deprecated. Use contentType instead."

	^ self contentType! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/4/2002 16:24'!
type: mimeType
	type := mimeType! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/27/2005 10:55'!
uri
	"Answer the URL the receiver was downloaded from.  It may legitimately be nil."

	^uri! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/27/2005 10:53'!
uri: aURI
	uri := aURI! !

!MIMEDocument methodsFor: 'accessing' stamp: 'mir 3/27/2005 10:55'!
url
	"Answer the URL the receiver was downloaded from.  It may legitimately be nil."

	^ uri asString! !

MIMEDocument subclass: #MIMELocalFileDocument
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Network-MIME'!

!MIMELocalFileDocument commentStamp: '<historical>' prior: 0!
For local files, we do not read the entire contents unless we absolutely have to.!

!MIMELocalFileDocument class methodsFor: 'instance creation' stamp: 'ar 4/24/2001 16:31'!
contentType: aString contentStream: aStream
	^(self contentType: aString content: nil) contentStream: aStream! !

!MIMELocalFileDocument methodsFor: 'accessing' stamp: 'michael.rueger 1/8/2009 19:19'!
content
	^contents ifNil:[contents := contentStream contentsOfEntireFile].! !

!MIMELocalFileDocument methodsFor: 'accessing' stamp: 'ar 4/24/2001 16:27'!
contentStream
	^contentStream ifNil:[super contentStream]! !

!MIMELocalFileDocument methodsFor: 'accessing' stamp: 'michael.rueger 1/8/2009 19:20'!
contentStream: aFileStream
	contentStream := aFileStream.
	contents := nil.! !

Object subclass: #MIMEType
	instanceVariableNames: 'main sub parameters'
	classVariableNames: 'DefaultSuffixes StandardMIMEMappings'
	poolDictionaries: ''
	category: 'Network-MIME'!

!MIMEType class methodsFor: 'instance creation' stamp: 'mir 3/6/2002 13:07'!
contentTypeURLEncoded
	^self main: 'application' sub: 'x-www-form-urlencoded'! !

!MIMEType class methodsFor: 'instance creation' stamp: 'mir 3/4/2002 17:06'!
defaultHTML
	^self main: 'text' sub: 'html'! !

!MIMEType class methodsFor: 'instance creation' stamp: 'mir 3/4/2002 15:25'!
defaultStream
	^self main: 'application' sub: 'octet-stream'! !

!MIMEType class methodsFor: 'accessing' stamp: 'michael.rueger 2/24/2009 18:42'!
defaultSuffixes
	"MIMEType defaultSuffixes"

	^DefaultSuffixes! !

!MIMEType class methodsFor: 'instance creation' stamp: 'mir 3/4/2002 15:23'!
defaultText
	^self main: 'text' sub: 'plain'! !

!MIMEType class methodsFor: 'instance creation' stamp: 'michael.rueger 2/9/2009 15:02'!
forExtensionReturnMimeTypesOrNil: fileExtension
	| loweredFileExtension |

	loweredFileExtension := fileExtension asLowercase.

"	Disabled for now as the default Pharo image does not have FFI included.
	Should probably be moved into a future version of the directory plugin.
	SmalltalkImage current platformName = 'Mac OS'
		ifTrue: 
			[loweredFileExtension = '' ifTrue: [^nil].
			mime :=  MacUTI callGetMimeTypeOrNilForFileExtension: loweredFileExtension].
			mime ifNotNil: [^Array with: mime].
"
	^self mimeMappings at: loweredFileExtension ifAbsent: [^nil]! !

!MIMEType class methodsFor: 'instance creation' stamp: 'JMM 12/1/2007 17:03'!
forFileNameReturnMimeTypesOrDefault: fileName
	| mimeTypes |
	mimeTypes := self forFileNameReturnMimeTypesOrNil: fileName.
	mimeTypes ifNil: [^Array with: (MIMEType defaultStream)].
	^mimeTypes! !

!MIMEType class methodsFor: 'instance creation' stamp: 'michael.rueger 2/9/2009 15:02'!
forFileNameReturnMimeTypesOrNil: fileName
	| ext |

	ext := FileDirectory extensionFor: fileName.

"	Disabled for now as the default Pharo image does not have FFI included.
	Should probably be moved into a future version of the directory plugin.
	SmalltalkImage current platformName = 'Mac OS'
		 ifTrue: 
			[type := MacUTI callGetMimeTypeOrNilForFileExtension: ext.
			type ifNil: 
					[fileType := (FileDirectory default getMacFileTypeAndCreator: fileName) at: 1.
					(fileType = '????' or: [fileType = ((ByteArray new: 4 withAll:0) asString asByteString)])
						ifTrue: [^self forExtensionReturnMimeTypesOrNil: ext].
					consider := MacUTI callGetMimeTypeOrNilForOSType: fileType.
					consider ifNotNil: [^Array with: consider]]
				ifNotNil: 
					[^Array with: type]].
"
	^self forExtensionReturnMimeTypesOrNil: ext! !

!MIMEType class methodsFor: 'instance creation' stamp: 'JMM 12/1/2007 23:02'!
forFileNameReturnSingleMimeTypeOrDefault: fileName
	| types |
	types := self forFileNameReturnMimeTypesOrDefault: fileName.
	^types first! !

!MIMEType class methodsFor: 'instance creation' stamp: 'JMM 12/1/2007 12:19'!
forFileNameReturnSingleMimeTypeOrNil: fileName
	| types |
	types := self forFileNameReturnMimeTypesOrNil: fileName.
	types ifNotNil: [^types first].
	^nil! !

!MIMEType class methodsFor: 'instance creation' stamp: 'mir 2/16/2006 23:33'!
fromMIMEString: mimeString
	| idx main rest sub parameters |
	idx := mimeString indexOf: $/.
	idx = 0
		ifTrue: [self error: 'Illegal mime type string "' , mimeString , '".'].
	main := mimeString copyFrom: 1 to: idx-1.
	rest := mimeString copyFrom: idx+1 to: mimeString size.
	idx := mimeString indexOf: $;.
	idx = 0
		ifTrue: [sub := rest]
		ifFalse: [
			sub := rest copyFrom: 1 to: idx.
			parameters := rest copyFrom: idx+1 to: rest size].
	 ^self
		main: main
		sub: sub
		parameters: parameters
! !

!MIMEType class methodsFor: 'accessing' stamp: 'JMM 10/2/2006 12:38'!
huntForDashAndRemove: aString
	| n |
	(n := aString lastIndexOf: $-) > 0 ifTrue: [^aString copyFrom: n+1 to: aString size].
	^aString
! !

!MIMEType class methodsFor: 'class initialization' stamp: 'michael.rueger 2/24/2009 18:42'!
initialize
	"MIMEType initialize" 

	self initializeStandardMIMETypes.   
	self initializeDefaultSuffixes! !

!MIMEType class methodsFor: 'class initialization' stamp: 'MarcusDenker 1/24/2010 11:09'!
initializeDefaultSuffixes
	"MIMEType initializeDefaultSuffixes"

	DefaultSuffixes := Dictionary new: 43.
	DefaultSuffixes
	at: 'application/freeloader' put: 'frl';
	at: 'application/gzip' put: 'gz';
	at: 'application/ips' put: 'ips';
	at: 'application/mac-binhex40' put: 'hqx';
	at: 'application/mac-compactpro' put: 'cpt';
	at: 'application/ms-word-document' put: 'doc';
	at: 'application/msword' put: 'doc';
	at: 'application/octet-stream' put: 'o';
	at: 'application/oda' put: 'oda';
	at: 'application/olescript' put: 'axs';
	at: 'application/pcphoto' put: 'zpa';
	at: 'application/pdf' put: 'pdf';
	at: 'application/postscript' put: 'ps';
	at: 'application/rtc' put: 'rtc';
	at: 'application/rtf' put: 'rtf';
	at: 'application/toolbook' put: 'tbk';
	at: 'application/vnd.ms-excel' put: 'xls';
	at: 'application/vnd.ms-powerpoint' put: 'pps';
	at: 'application/x-DemoShield' put: 'wid';
	at: 'application/x-authorware-map' put: 'aas';
	at: 'application/x-bcpio' put: 'bcpio';
	at: 'application/x-chat' put: 'chat';
	at: 'application/x-compress' put: 'z';
	at: 'application/x-connector' put: 'con';
	at: 'application/x-cpio' put: 'cpio';
	at: 'application/x-csh' put: 'csh';
	at: 'application/x-dvi' put: 'dvi';
	at: 'application/x-expandedbook' put: 'ebk';
	at: 'application/x-fontbitmap' put: 'pcf';
	at: 'application/x-fontdataforktruetype' put: 'dfont';
	at: 'application/x-fontopentype' put: 'otf';
	at: 'application/x-fontpostscripttype1' put: 'pfa';
	at: 'application/x-fontsuitcase' put: 'suit';
	at: 'application/x-fonttruetype' put: 'ttf';
	at: 'application/x-gtar' put: 'gtar';
	at: 'application/x-hdf' put: 'hdf';
	at: 'application/x-javascript' put: 'js';
	at: 'application/x-latex' put: 'latex';
	at: 'application/x-msaddr' put: 'adr';
	at: 'application/x-mswallet' put: 'wlt';
	at: 'application/x-netcdf' put: 'cdf';
	at: 'application/x-pgp-plugin' put: 'pgp';
	at: 'application/x-sh' put: 'sh';
	at: 'application/x-shar' put: 'shar';
	at: 'application/x-shockwave-flash' put: 'swf';
	at: 'application/x-stuffit' put: 'sit';
	at: 'application/x-sv4cpio' put: 'sv4cpio';
	at: 'application/x-sv4crc' put: 'sv4crc';
	at: 'application/x-tar' put: 'tar';
	at: 'application/x-texinfo' put: 'texi';
	at: 'application/x-troff' put: 'tr';
	at: 'application/x-troff-man' put: 'man';
	at: 'application/x-troff-me' put: 'me';
	at: 'application/x-troff-ms' put: 'ms';
	at: 'application/x-wais-source' put: 'wsrc';
	at: 'application/x.tex' put: 'tex';
	at: 'application/zip' put: 'zip';
	at: 'audio/aiff' put: 'aiff';
	at: 'audio/basic' put: 'au';
	at: 'audio/midi' put: 'midi';
	at: 'audio/mpeg' put: 'mp3';
	at: 'audio/wav' put: 'wav';
	at: 'audio/x-aiff' put: 'aiff';
	at: 'audio/x-dspeech' put: 'cht';
	at: 'audio/x-midi' put: 'mid';
	at: 'audio/x-mp4-audio' put: 'm4';
	at: 'audio/x-ms-wma' put: 'wma';
	at: 'audio/x-pn-realaudio' put: 'ram';
	at: 'audio/x-pn-realaudio-plugin' put: 'rpm';
	at: 'audio/x-quicktime-protected' put: 'm4p';
	at: 'audio/x-quicktime-protected-b' put: 'm4b';
	at: 'audio/x-realaudio' put: 'ra';
	at: 'audio/x-wav' put: 'wav';
	at: 'i-world/i-vrml' put: 'ivr';
	at: 'image/bmp' put: 'bmp';
	at: 'image/gif' put: 'gif';
	at: 'image/ief' put: 'ief';
	at: 'image/jpeg' put: 'jpg';
	at: 'image/png' put: 'png';
	at: 'image/tiff' put: 'tiff';
	at: 'image/vnd' put: 'dxf';
	at: 'image/vnd' put: 'dwg';
	at: 'image/x-cmu-rast' put: 'ras';
	at: 'image/x-freehand' put: 'fhc';
	at: 'image/x-portable-anymap' put: 'pnm';
	at: 'image/x-portable-bitmap' put: 'pbm';
	at: 'image/x-portable-graymap' put: 'pgm';
	at: 'image/x-portable-pixmap' put: 'ppm';
	at: 'image/x-rgb' put: 'rgb';
	at: 'image/x-xbitmap' put: 'xbm';
	at: 'image/x-xwindowdump' put: 'xwd';
	at: 'message/rfc822' put: 'mime';
	at: 'model/vrml' put: 'vrml';
	at: 'text/css' put: 'css';
	at: 'text/html' put: 'html';
	at: 'text/parsnegar-document' put: 'pgr';
	at: 'text/plain' put: 'text';
	at: 'text/rtf' put: 'rtf';
	at: 'text/tab-separated-values' put: 'tsv';
	at: 'text/x-css' put: 'css';
	at: 'text/x-setext' put: 'etx';
	at: 'text/xml' put: 'xml';
	at: 'video/avi' put: 'avi';
	at: 'video/mov' put: 'mov';
	at: 'video/mpeg' put: 'mpeg';
	at: 'video/mpg' put: 'mpg';
	at: 'video/quicktime' put: 'qt';
	at: 'video/vnd.vivo' put: 'vivo';
	at: 'video/x-mp4-video' put: 'mp4v';
	at: 'video/x-mpeg' put: 'mpeg';
	at: 'video/x-ms-asf' put: 'asf';
	at: 'video/x-ms-asf' put: 'asx';
	at: 'video/x-ms-wm' put: 'wm';
	at: 'video/x-ms-wmv' put: 'wmv';
	at: 'video/x-sgi.movie' put: 'movie';
	at: 'video/x-videogram' put: 'vgm';
	at: 'video/x-videogram-plugin' put: 'vgp'.
	^DefaultSuffixes


"| stream reverse |
stream := StandardFileStream forceNewFileNamed: 'foobar.txt'.
reverse := OrderedCollection new. 
MIMEType mimeMappings associationsDo: [:m |
	m value do: [:e | reverse add: m key->e]].
sorted := SortedCollection sortBlock: [:n1 :n2 | n1 value printString <= n2 value printString].
sorted addAll: reverse.
sorted do: [:s | 
	stream nextPutAll: '	at: '''.
	stream nextPutAll: s value printString.
	stream nextPutAll: ''' put: '''.
	stream nextPutAll: s key.
	stream nextPutAll: ''';';cr].
stream close."
! !

!MIMEType class methodsFor: 'class initialization' stamp: 'michael.rueger 2/24/2009 18:43'!
initializeStandardMIMETypes
	"MIMEType initializeStandardMIMETypes"

	StandardMIMEMappings := Dictionary new.
	self standardMIMETypes keysAndValuesDo:[:extension :mimeStrings |
		StandardMIMEMappings
			at: extension asString asLowercase
			put: (mimeStrings collect: [:mimeString | MIMEType fromMIMEString: mimeString]).
	].! !

!MIMEType class methodsFor: 'instance creation' stamp: 'mir 3/4/2002 15:22'!
main: mainType sub: subType
	^self new
		main: mainType;
		sub: subType! !

!MIMEType class methodsFor: 'instance creation' stamp: 'mir 2/16/2006 23:33'!
main: mainType sub: subType parameters: parameters
	^self new
		main: mainType;
		sub: subType;
		parameters: parameters! !

!MIMEType class methodsFor: 'accessing' stamp: 'mir 3/4/2002 16:15'!
mimeMappings
	^StandardMIMEMappings! !

!MIMEType class methodsFor: 'accessing' stamp: 'JMM 12/2/2007 14:32'!
simpleSuffixForMimeType: mimeType
	^(self defaultSuffixes at: mimeType printString ifAbsent: [self  huntForDashAndRemove: mimeType sub]) asSymbol! !

!MIMEType class methodsFor: 'class initialization' stamp: 'MarcusDenker 1/24/2010 11:10'!
standardMIMETypes
	"We had to split this method because of the 256 literal limit in methods.
	Please keep it in alphabetical order for easier maintenance."
	"MIMEType standardMIMETypes"

	| mimeTypes |
	mimeTypes := self standardMIMETypes2.
	mimeTypes
		at: 'a' put: #('application/octet-stream');
		at: 'aam' put: #('application/x-authorware-map');
		at: 'aas' put: #('application/x-authorware-map');
		at: 'adr' put: #('application/x-msaddr');
		at: 'ai' put: #('application/postscript');
		at: 'aif' put: #('audio/x-aiff');
		at: 'aifc' put: #('audio/x-aiff');
		at: 'aiff' put: #('audio/aiff' 'audio/x-aiff');
		at: 'arc' put: #('application/octet-stream');
		at: 'asf' put: #('video/x-ms-asf');
		at: 'asx' put: #('video/x-ms-asf');
		at: 'au' put: #('audio/basic');
		at: 'avi' put: #('video/avi');
		at: 'axs' put: #('application/olescript');
		at: 'bcpio' put: #('application/x-bcpio');
		at: 'bdf' put: #('application/x-fontbitmap');
		at: 'bin' put: #('application/octet-stream');
		at: 'bmp' put: #('image/bmp');
		at: 'c' put: #('text/plain');
		at: 'cdf' put: #('application/x-netcdf');
		at: 'chat' put: #('application/x-chat');
		at: 'cht' put: #('audio/x-dspeech');
		at: 'class' put: #('application/octet-stream');
		at: 'con' put: #('application/x-connector');
		at: 'cpio' put: #('application/x-cpio');
		at: 'cpp' put: #('text/plain');
		at: 'cpt' put: #('application/mac-compactpro');
		at: 'csh' put: #('application/x-csh');
		at: 'css' put: #('text/css' 'text/x-css');
		at: 'dfon' put: #('application/x-fontdataforktruetype');
		at: 'dfont' put: #('application/x-fontdataforktruetype');
		at: 'dms' put: #('application/octet-stream');
		at: 'doc' put: #('application/ms-word-document' 'application/msword');
		at: 'dot' put: #('application/msword');
		at: 'dump' put: #('application/octet-stream');
		at: 'dus' put: #('audio/x-dspeech');
		at: 'dvi' put: #('application/x-dvi');
		at: 'dwg' put: #('image/vnd');
		at: 'dxf' put: #('image/vnd');
		at: 'ebk' put: #('application/x-expandedbook');
		at: 'eps' put: #('application/postscript');
		at: 'etx' put: #('text/x-setext');
		at: 'exe' put: #('application/octet-stream');
		at: 'ffil' put: #('application/x-fontsuitcase');
		at: 'fh4' put: #('image/x-freehand');
		at: 'fh5' put: #('image/x-freehand');
		at: 'fhc' put: #('image/x-freehand');
		at: 'frl' put: #('application/freeloader');
		at: 'gif' put: #('image/gif');
		at: 'gtar' put: #('application/x-gtar');
		at: 'gtaru' put: #('application/x-gtar');
		at: 'gz' put: #('application/gzip');
		at: 'h' put: #('text/plain');
		at: 'hdf' put: #('application/x-hdf');
		at: 'hqx' put: #('application/mac-binhex40' 'application/octet-stream');
		at: 'htm' put: #('text/html' 'text/plain');
		at: 'html' put: #('text/html' 'text/plain');
		at: 'ief' put: #('image/ief');
		at: 'ips' put: #('application/ips');
		at: 'ivr' put: #('i-world/i-vrml');
		at: 'java' put: #('text/plain');
		at: 'jfif' put: #('image/jpeg');
		at: 'jfif-tbnl' put: #('image/jpeg');
		at: 'jpe' put: #('image/jpeg');
		at: 'jpeg' put: #('image/jpeg');
		at: 'jpg' put: #('image/jpeg');
		at: 'js' put: #('application/x-javascript');
		at: 'latex' put: #('application/x-latex');
		at: 'lha' put: #('application/octet-stream');
		at: 'lwfn' put: #('application/x-fontpostscripttype1');
		at: 'lzh' put: #('application/octet-stream');
		at: 'm4' put: #('audio/x-mp4-audio');
		at: 'm4b' put: #('audio/x-quicktime-protected-b');
		at: 'm4p' put: #('audio/x-quicktime-protected');
		at: 'm4v' put: #('video/x-mp4-video');
		at: 'man' put: #('application/x-troff-man');
		at: 'me' put: #('application/x-troff-me');
		at: 'mid' put: #('audio/midi' 'audio/x-midi');
		at: 'midi' put: #('audio/midi');
		at: 'mime' put: #('message/rfc822');
		at: 'mov' put: #('video/mov');
		at: 'movie' put: #('video/x-sgi-movie' 'video/x-sgi.movie');
		at: 'mp2' put: #('audio/mpeg');
		at: 'mp3' put: #('audio/mpeg' 'audio/x-mpeg');
		at: 'mp4' put: #('video/x-mp4-video');
		at: 'mp4v' put: #('video/x-mp4-video');
		at: 'mpe' put: #('video/mpeg');
		at: 'mpeg' put: #('video/mpeg' 'video/x-mpeg');
		at: 'mpg' put: #('video/mpg' 'video/mpeg' 'video/x-mpeg');
		at: 'mpga' put: #('audio/mpeg');
		at: 'ms' put: #('application/x-troff-ms');
		at: 'mv' put: #('video/x-sgi-movie').
	^mimeTypes! !

!MIMEType class methodsFor: 'class initialization' stamp: 'MarcusDenker 1/24/2010 11:09'!
standardMIMETypes2
	"MIMEType standardMimeTypes2"
	"We had to split this method because of the 256 literal limit in methods."
	| mimeTypes |
	mimeTypes := Dictionary new: 100.
	mimeTypes
		at: 'nc' put: #('application/x-netcdf');
		at: 'o' put: #('application/octet-stream');
		at: 'oda' put: #('application/oda');
		at: 'ogg' put: #('audio/ogg');
		at: 'otf' put: #('application/x-fontopentype');
		at: 'otto' put: #('application/x-fontopentype');
		at: 'pbm' put: #('image/x-portable-bitmap');
		at: 'pcf' put: #('application/x-fontbitmap');
		at: 'pdf' put: #('application/pdf');
		at: 'pfa' put: #('application/x-fontpostscripttype1');
		at: 'pfb' put: #('application/x-fontpostscripttype1');
		at: 'pgm' put: #('image/x-portable-graymap');
		at: 'pgp' put: #('application/x-pgp-plugin');
		at: 'pgr' put: #('text/parsnegar-document');
		at: 'pl' put: #('text/plain');
		at: 'png' put: #('image/png');
		at: 'pnm' put: #('image/x-portable-anymap');
		at: 'pot' put: #('application/vnd.ms-powerpoint');
		at: 'ppa' put: #('application/vnd.ms-powerpoint');
		at: 'ppm' put: #('image/x-portable-pixmap');
		at: 'pps' put: #('application/vnd.ms-powerpoint');
		at: 'ppt' put: #('application/mspowerpoint');
		at: 'ppz' put: #('application/vnd.ms-powerpoint');
		at: 'pr' put: #('application/x-squeak-project');
		at: 'ps' put: #('application/postscript');
		at: 'pwz' put: #('application/vnd.ms-powerpoint');
		at: 'qt' put: #('video/quicktime');
		at: 'ra' put: #('audio/x-realaudio');
		at: 'ram' put: #('audio/x-pn-realaudio');
		at: 'ras' put: #('image/x-cmu-rast');
		at: 'rgb' put: #('image/x-rgb');
		at: 'rm' put: #('audio/x-pn-realaudio');
		at: 'roff' put: #('application/x-troff');
		at: 'rpm' put: #('audio/x-pn-realaudio-plugin');
		at: 'rtc' put: #('application/rtc');
		at: 'rtf' put: #('text/rtf' 'application/rtf');
		at: 'rtx' put: #('application/rtf');
		at: 'saveme' put: #('application/octet-stream');
		at: 'sfnt' put: #('application/x-fontsuitcase');
		at: 'sh' put: #('application/x-sh');
		at: 'shar' put: #('application/x-shar');
		at: 'sit' put: #('application/x-stuffit');
		at: 'snd' put: #('audio/basic');
		at: 'spx' put: #('audio/x-speex');
		at: 'src' put: #('application/x-wais-source');
		at: 'sts' put: #('application/x-squeak-source');
		at: 'suit' put: #('application/x-fontsuitcase');
		at: 'sv4cpio' put: #('application/x-sv4cpio');
		at: 'sv4crc' put: #('application/x-sv4crc');
		at: 'swf' put: #('application/x-shockwave-flash');
		at: 't' put: #('application/x-troff');
		at: 'tar' put: #('application/x-tar');
		at: 'tbk' put: #('application/toolbook');
		at: 'tex' put: #('application/x.tex');
		at: 'texi' put: #('application/x-texinfo');
		at: 'texinfo' put: #('application/x-texinfo');
		at: 'text' put: #('text/plain');
		at: 'tfil' put: #('application/x-fontsuitcase');
		at: 'tif' put: #('image/tiff');
		at: 'tiff' put: #('image/tiff');
		at: 'tr' put: #('application/x-troff');
		at: 'tsv' put: #('text/tab-separated-values');
		at: 'ttc' put: #('application/x-fonttruetype');
		at: 'ttcf' put: #('application/x-fonttruetype');
		at: 'ttf' put: #('application/x-fonttruetype');
		at: 'txt' put: #('text/plain');
		at: 'ua' put: #('text/plain');
		at: 'ustar' put: #('audio/basic');
		at: 'uu' put: #('application/octet-stream');
		at: 'vgm' put: #('video/x-videogram');
		at: 'vgp' put: #('video/x-videogram-plugin');
		at: 'vgx' put: #('video/x-videogram');
		at: 'viv' put: #('video/vnd.vivo');
		at: 'vivo' put: #('video/vnd.vivo');
		at: 'vrml' put: #('model/vrml');
		at: 'wav' put: #('audio/wav' 'audio/x-wav');
		at: 'wid' put: #('application/x-DemoShield');
		at: 'wiz' put: #('application/msword');
		at: 'wlt' put: #('application/x-mswallet');
		at: 'wm' put: #('video/x-ms-wm');
		at: 'wma' put: #('audio/x-ms-wma');
		at: 'wmv' put: #('video/x-ms-wmv');
		at: 'wrl' put: #('model/vrml');
		at: 'wsrc' put: #('application/x-wais-source');
		at: 'xbm' put: #('image/x-xbitmap');
		at: 'xlb' put: #('application/vnd.ms-excel');
		at: 'xls' put: #('application/vnd.ms-excel');
		at: 'xml' put: #('text/xml' 'text/html');
		at: 'xpm' put: #('image/x-xpixmap');
		at: 'xul' put: #('application/vnd.mozilla.xul+xml');
		at: 'xwd' put: #('image/x-xwindowdump');
		at: 'z' put: #('application/x-compress');
		at: 'zip' put: #('application/zip');
		at: 'zpa' put: #('application/pcphoto').
	^mimeTypes
! !

!MIMEType class methodsFor: 'accessing' stamp: 'JMM 12/2/2007 14:31'!
suffixForMimeType: mimeType
	^self defaultSuffixes at: mimeType printString ifAbsent: [mimeType sub]! !

!MIMEType methodsFor: 'comparing' stamp: 'mir 3/6/2002 12:11'!
= anotherObject
	anotherObject class == self class
		ifFalse: [^false].
	^self main = anotherObject main
		and: [self sub = anotherObject sub]! !

!MIMEType methodsFor: 'converting' stamp: 'mir 3/4/2002 18:21'!
asMIMEType
	^self! !

!MIMEType methodsFor: 'comparing' stamp: 'JMM 7/26/2006 16:26'!
beginsWith: aString
	^self printString beginsWith: aString! !

!MIMEType methodsFor: 'comparing' stamp: 'mir 12/17/2005 14:17'!
hash
	^self main hash bitXor: self sub hash! !

!MIMEType methodsFor: 'accessing' stamp: 'mir 3/4/2002 15:21'!
main
	^main! !

!MIMEType methodsFor: 'accessing' stamp: 'mir 3/4/2002 15:21'!
main: mainType
	main := mainType! !

!MIMEType methodsFor: 'accessing' stamp: 'mir 2/16/2006 23:33'!
parameters: params
	parameters := params! !

!MIMEType methodsFor: 'printing' stamp: 'mir 3/4/2002 16:14'!
printOn: stream
	stream
		nextPutAll: main; nextPut: $/ ; nextPutAll: sub! !

!MIMEType methodsFor: 'accessing' stamp: 'mir 3/4/2002 15:21'!
sub
	^sub! !

!MIMEType methodsFor: 'accessing' stamp: 'mir 3/4/2002 15:21'!
sub: subType
	sub := subType! !

!FileDirectory methodsFor: '*Network-MIME' stamp: 'JMM 5/14/2006 13:59'!
fileSuffixesForMimeType: mimeType
	"Return a list file suffixes for mime type. This is a suboptimal solution."

	| results |

	results := SortedCollection sortBlock: [:a :b | a size <= b size].
	MIMEType mimeMappings keysAndValuesDo: [:k :v | 
	v do: [: mime |
		mimeType = mime ifTrue: [results add: k]]].
	^results! !

!FileDirectory methodsFor: '*Network-MIME' stamp: 'JMM 12/1/2007 15:21'!
mimeTypesFor: fileName
	"Return a list of MIME types applicable to the receiver. This default implementation uses the file name extension to figure out what we're looking at but specific subclasses may use other means of figuring out what the type of some file is. Some systems like the macintosh use meta data on the file to indicate data type"

	^MIMEType forFileNameReturnMimeTypesOrDefault: fileName! !

!String methodsFor: '*network-mime' stamp: 'mir 2/16/2006 23:21'!
asMIMEType
	^MIMEType fromMIMEString: self! !

!String methodsFor: '*network-mime' stamp: 'StephaneDucasse 9/1/2009 15:50'!
base64Encoded
	"Encode the receiver as base64"
	"'Hello World' base64Encoded"
	^(Base64MimeConverter mimeEncode: self readStream) contents! !
MIMEType initialize!
